<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_award".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderAward".
 *
 * Columns in table "provider_award" available as properties of the model,
 * followed by relations of table "provider_award" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property string $award_name
 * @property string $awarding_institution
 * @property string $received_years
 *
 * @property Provider $provider
 */
abstract class BaseProviderAward extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_award';
    }

    public static function representingColumn()
    {
        return 'award_name';
    }

    public function rules()
    {
        return array(
            array('provider_id, award_name, awarding_institution', 'required'),
            array('provider_id', 'numerical', 'integerOnly' => true),
            array('award_name, awarding_institution', 'length', 'max' => 70),
            array('received_years', 'length', 'max' => 60),
            array('id, provider_id, award_name, awarding_institution, received_years', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'award_name' => Yii::t('app', 'Award Name'),
            'awarding_institution' => Yii::t('app', 'Awarding Institution'),
            'received_years' => Yii::t('app', 'Received Years (CSV)'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        //eager loading
        $criteria->with = 'provider';

        $criteria->compare('id', $this->id);
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->compare('provider.first_last', $this->provider_id, true);
        } elseif (intval($this->provider_id)) {
            $criteria->compare('provider_id', $this->provider_id);
        }
        $criteria->compare('award_name', $this->award_name, true);
        $criteria->compare('awarding_institution', $this->awarding_institution, true);
        $criteria->compare('received_years', $this->received_years, true);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderAward|ProviderAwards', $n);
    }

}
